package com.app.kemenhub.jakbanapps.db;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;

import de.greenrobot.dao.AbstractDao;
import de.greenrobot.dao.Property;
import de.greenrobot.dao.internal.DaoConfig;

import com.app.kemenhub.jakbanapps.db.kecamatan;

// THIS CODE IS GENERATED BY greenDAO, DO NOT EDIT.
/** 
 * DAO for table "KECAMATAN".
*/
public class kecamatanDao extends AbstractDao<kecamatan, Long> {

    public static final String TABLENAME = "KECAMATAN";

    /**
     * Properties of entity kecamatan.<br/>
     * Can be used for QueryBuilder and for referencing column names.
    */
    public static class Properties {
        public final static Property Id = new Property(0, Long.class, "id", true, "_id");
        public final static Property Kabupaten_id = new Property(1, String.class, "kabupaten_id", false, "KABUPATEN_ID");
        public final static Property Nama = new Property(2, String.class, "nama", false, "NAMA");
    };


    public kecamatanDao(DaoConfig config) {
        super(config);
    }
    
    public kecamatanDao(DaoConfig config, DaoSession daoSession) {
        super(config, daoSession);
    }

    /** Creates the underlying database table. */
    public static void createTable(SQLiteDatabase db, boolean ifNotExists) {
        String constraint = ifNotExists? "IF NOT EXISTS ": "";
        db.execSQL("CREATE TABLE " + constraint + "\"KECAMATAN\" (" + //
                "\"_id\" INTEGER PRIMARY KEY ," + // 0: id
                "\"KABUPATEN_ID\" TEXT," + // 1: kabupaten_id
                "\"NAMA\" TEXT);"); // 2: nama
    }

    /** Drops the underlying database table. */
    public static void dropTable(SQLiteDatabase db, boolean ifExists) {
        String sql = "DROP TABLE " + (ifExists ? "IF EXISTS " : "") + "\"KECAMATAN\"";
        db.execSQL(sql);
    }

    /** @inheritdoc */
    @Override
    protected void bindValues(SQLiteStatement stmt, kecamatan entity) {
        stmt.clearBindings();
 
        Long id = entity.getId();
        if (id != null) {
            stmt.bindLong(1, id);
        }
 
        String kabupaten_id = entity.getKabupaten_id();
        if (kabupaten_id != null) {
            stmt.bindString(2, kabupaten_id);
        }
 
        String nama = entity.getNama();
        if (nama != null) {
            stmt.bindString(3, nama);
        }
    }

    /** @inheritdoc */
    @Override
    public Long readKey(Cursor cursor, int offset) {
        return cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0);
    }    

    /** @inheritdoc */
    @Override
    public kecamatan readEntity(Cursor cursor, int offset) {
        kecamatan entity = new kecamatan( //
            cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0), // id
            cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1), // kabupaten_id
            cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2) // nama
        );
        return entity;
    }
     
    /** @inheritdoc */
    @Override
    public void readEntity(Cursor cursor, kecamatan entity, int offset) {
        entity.setId(cursor.isNull(offset + 0) ? null : cursor.getLong(offset + 0));
        entity.setKabupaten_id(cursor.isNull(offset + 1) ? null : cursor.getString(offset + 1));
        entity.setNama(cursor.isNull(offset + 2) ? null : cursor.getString(offset + 2));
     }
    
    /** @inheritdoc */
    @Override
    protected Long updateKeyAfterInsert(kecamatan entity, long rowId) {
        entity.setId(rowId);
        return rowId;
    }
    
    /** @inheritdoc */
    @Override
    public Long getKey(kecamatan entity) {
        if(entity != null) {
            return entity.getId();
        } else {
            return null;
        }
    }

    /** @inheritdoc */
    @Override    
    protected boolean isEntityUpdateable() {
        return true;
    }
    
}
